<?php

/**
 * @file
 * Field validation IBAN validator.
 */

$plugin = array(
  'label' => t('IBAN'),
  'description' => t('Validates IBAN using <a href="@url">PHP-IBAN</a> library.', array('@url' => url('https://github.com/globalcitizen/php-iban'))),
  'handler' => array('class' => 'field_validation_iban_validator'),
);

/**
 * Validator class.
 */
class field_validation_iban_validator extends field_validation_validator {

  /**
   * Validate field.
   */
  public function validate() {
    if (!$this->value) {
      // Don't validate empty field. This is up to the required-field validator.
      return;
    }
    // Load library.
    if (($library = libraries_load('php-iban')) && !empty($library['loaded'])) {
      // Verify value.
      if (!verify_iban($this->value)) {
        $this->set_error();
      }
    }
    else {
      // No library, no validation.
      $this->set_error();
    }
  }

}
